
package net.mcreator.dreamzzz.item;

import net.minecraftforge.registries.ForgeRegistries;

import net.minecraft.world.level.Level;
import net.minecraft.world.item.crafting.Ingredient;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.Item;
import net.minecraft.world.item.ArmorMaterial;
import net.minecraft.world.item.ArmorItem;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.entity.EquipmentSlot;
import net.minecraft.world.entity.Entity;
import net.minecraft.sounds.SoundEvent;
import net.minecraft.resources.ResourceLocation;

import net.mcreator.dreamzzz.procedures.DreamyDiamondsArmorLeggingsTickEventProcedure;
import net.mcreator.dreamzzz.procedures.DreamyDiamondsArmorHelmetTickEventProcedure;
import net.mcreator.dreamzzz.procedures.DreamyDiamondsArmorChestplateTickEventProcedure;
import net.mcreator.dreamzzz.procedures.DreamyDiamondsArmorBootsTickEventProcedure;
import net.mcreator.dreamzzz.init.DreamzzzModItems;

public abstract class DreamyDiamondsArmorItem extends ArmorItem {
	public DreamyDiamondsArmorItem(ArmorItem.Type type, Item.Properties properties) {
		super(new ArmorMaterial() {
			@Override
			public int getDurabilityForType(ArmorItem.Type type) {
				return new int[]{13, 15, 16, 11}[type.getSlot().getIndex()] * 150;
			}

			@Override
			public int getDefenseForType(ArmorItem.Type type) {
				return new int[]{20, 60, 50, 20}[type.getSlot().getIndex()];
			}

			@Override
			public int getEnchantmentValue() {
				return 90;
			}

			@Override
			public SoundEvent getEquipSound() {
				return ForgeRegistries.SOUND_EVENTS.getValue(new ResourceLocation("item.armor.equip_diamond"));
			}

			@Override
			public Ingredient getRepairIngredient() {
				return Ingredient.of(new ItemStack(DreamzzzModItems.DREAMY_DIAMONDS.get()));
			}

			@Override
			public String getName() {
				return "dreamy_diamonds_armor";
			}

			@Override
			public float getToughness() {
				return 0f;
			}

			@Override
			public float getKnockbackResistance() {
				return 0f;
			}
		}, type, properties);
	}

	public static class Helmet extends DreamyDiamondsArmorItem {
		public Helmet() {
			super(ArmorItem.Type.HELMET, new Item.Properties());
		}

		@Override
		public String getArmorTexture(ItemStack stack, Entity entity, EquipmentSlot slot, String type) {
			return "dreamzzz:textures/models/armor/fdfd_layer_1.png";
		}

		@Override
		public void onArmorTick(ItemStack itemstack, Level world, Player entity) {
			DreamyDiamondsArmorHelmetTickEventProcedure.execute(entity);
		}
	}

	public static class Chestplate extends DreamyDiamondsArmorItem {
		public Chestplate() {
			super(ArmorItem.Type.CHESTPLATE, new Item.Properties());
		}

		@Override
		public String getArmorTexture(ItemStack stack, Entity entity, EquipmentSlot slot, String type) {
			return "dreamzzz:textures/models/armor/fdfd_layer_1.png";
		}

		@Override
		public void onArmorTick(ItemStack itemstack, Level world, Player entity) {
			DreamyDiamondsArmorChestplateTickEventProcedure.execute(entity);
		}
	}

	public static class Leggings extends DreamyDiamondsArmorItem {
		public Leggings() {
			super(ArmorItem.Type.LEGGINGS, new Item.Properties());
		}

		@Override
		public String getArmorTexture(ItemStack stack, Entity entity, EquipmentSlot slot, String type) {
			return "dreamzzz:textures/models/armor/fdfd_layer_2.png";
		}

		@Override
		public void onArmorTick(ItemStack itemstack, Level world, Player entity) {
			DreamyDiamondsArmorLeggingsTickEventProcedure.execute(entity);
		}
	}

	public static class Boots extends DreamyDiamondsArmorItem {
		public Boots() {
			super(ArmorItem.Type.BOOTS, new Item.Properties());
		}

		@Override
		public String getArmorTexture(ItemStack stack, Entity entity, EquipmentSlot slot, String type) {
			return "dreamzzz:textures/models/armor/fdfd_layer_1.png";
		}

		@Override
		public void onArmorTick(ItemStack itemstack, Level world, Player entity) {
			DreamyDiamondsArmorBootsTickEventProcedure.execute(entity);
		}
	}
}
